Index: orxonox/trunk/configure
===================================================================
--- orxonox/trunk/configure	(revision 3239)
+++ orxonox/trunk/configure	(revision 3240)
@@ -1,7 +1,7 @@
 #! /bin/sh
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.59 for orxonox 0.2.0_alpha-r1.
+# Generated by GNU Autoconf 2.59 for orxonox 2.0.1-pre-alpha.
 #
-# Report bugs to <orxonox-dev@mail.datacore.ch>.
+# Report bugs to <orxonox-dev at mail.datacore.ch>.
 #
 # Copyright (C) 2003 Free Software Foundation, Inc.
@@ -270,7 +270,7 @@
 PACKAGE_NAME='orxonox'
 PACKAGE_TARNAME='orxonox'
-PACKAGE_VERSION='0.2.0_alpha-r1'
-PACKAGE_STRING='orxonox 0.2.0_alpha-r1'
-PACKAGE_BUGREPORT='orxonox-dev@mail.datacore.ch'
+PACKAGE_VERSION='2.0.1-pre-alpha'
+PACKAGE_STRING='orxonox 2.0.1-pre-alpha'
+PACKAGE_BUGREPORT='orxonox-dev at mail.datacore.ch'
 
 ac_unique_file="."
@@ -789,5 +789,5 @@
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures orxonox 0.2.0_alpha-r1 to adapt to many kinds of systems.
+\`configure' configures orxonox 2.0.1-pre-alpha to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
@@ -856,5 +856,5 @@
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of orxonox 0.2.0_alpha-r1:";;
+     short | recursive ) echo "Configuration of orxonox 2.0.1-pre-alpha:";;
    esac
   cat <<\_ACEOF
@@ -888,5 +888,5 @@
 it to find libraries and programs with nonstandard names/locations.
 
-Report bugs to <orxonox-dev@mail.datacore.ch>.
+Report bugs to <orxonox-dev at mail.datacore.ch>.
 _ACEOF
 fi
@@ -984,5 +984,5 @@
 if $ac_init_version; then
   cat <<\_ACEOF
-orxonox configure 0.2.0_alpha-r1
+orxonox configure 2.0.1-pre-alpha
 generated by GNU Autoconf 2.59
 
@@ -998,5 +998,5 @@
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by orxonox $as_me 0.2.0_alpha-r1, which was
+It was created by orxonox $as_me 2.0.1-pre-alpha, which was
 generated by GNU Autoconf 2.59.  Invocation command line was
 
@@ -1719,5 +1719,5 @@
 # Define the identity of the package.
  PACKAGE='orxonox'
- VERSION='0.2.0_alpha-r1'
+ VERSION='2.0.1-pre-alpha'
 
 
@@ -4167,7 +4167,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -4397,7 +4397,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -4692,7 +4692,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -5002,7 +5002,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -5231,7 +5231,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -5465,7 +5465,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -5712,7 +5712,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -5867,7 +5867,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -6051,7 +6051,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -6282,7 +6282,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -6511,7 +6511,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -7022,7 +7022,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -7334,7 +7334,7 @@
     (
       cat <<\_ASBOX
-## ------------------------------------------- ##
-## Report this to orxonox-dev@mail.datacore.ch ##
-## ------------------------------------------- ##
+## ---------------------------------------------- ##
+## Report this to orxonox-dev at mail.datacore.ch ##
+## ---------------------------------------------- ##
 _ASBOX
     ) |
@@ -7946,5 +7946,5 @@
 cat >&5 <<_CSEOF
 
-This file was extended by orxonox $as_me 0.2.0_alpha-r1, which was
+This file was extended by orxonox $as_me 2.0.1-pre-alpha, which was
 generated by GNU Autoconf 2.59.  Invocation command line was
 
@@ -8009,5 +8009,5 @@
 cat >>$CONFIG_STATUS <<_ACEOF
 ac_cs_version="\\
-orxonox config.status 0.2.0_alpha-r1
+orxonox config.status 2.0.1-pre-alpha
 configured by $0, generated by GNU Autoconf 2.59,
   with options \\"`echo "$ac_configure_args" | sed 's/[\\""\`\$]/\\\\&/g'`\\"
Index: orxonox/trunk/configure.ac
===================================================================
--- orxonox/trunk/configure.ac	(revision 3239)
+++ orxonox/trunk/configure.ac	(revision 3240)
@@ -3,5 +3,5 @@
 
 AC_PREREQ(2.56)
-AC_INIT(orxonox, 0.2.0_alpha-r1, orxonox-dev@mail.datacore.ch)
+AC_INIT(orxonox, 0.2.1-pre-alpha, [orxonox-dev at mail.datacore.ch])
 
 # Detect the canonical host and target build environment.